<template>
  <div class="container">
    <div class="info">
      <h4>
        <p>
          <InfoCircleIcon />
          Access to RISIS datasets listed below, is free of charge and is
          offered through a two-step process:<br />
        </p>
        <p>
          I) Accreditation: Registered users have agreed on the conditions of
          use (good use of data, authorship, mentions to the RISIS project,
          agreement of posting results and aggregated datasets produced on RISIS
          via signing the
          <NuxtLink v-b-modal.modal-codeofconduct to="#" class="link-secondary"
            >RISIS Code of Conduct</NuxtLink
          >.
        </p>

        <p>
          II) Selection: researchers need to propose a project (200 words) based
          upon the mobilisation of one or more datasets. Projects are reviewed
          both by the dataset producers and by the RISIS project review board
          that will give the final agreement for access.
        </p>
        <p>
          Access is foreseen to be in principle at distance (online via RCF). In
          some cases, physical visits to a specific datasets location are
          possible with travel costs covered by the applicant themselves
        </p>
        <p>
          All datasets can be accessed by selecting the needed Dataset(s) here:
          <b-button :href="'/access-request/new'">Make Access Request</b-button>
        </p>
      </h4>
    </div>

    <div class="list">
      <div v-for="dataset in datasets" :key="dataset.id" class="list-item">
        <div class="title">{{ dataset.label }}</div>
        <div class="short-description">{{ dataset.short_description }}</div>
        <b-button
          class="metadata-button col-2"
          @click="setDisplayMetadataDataset(dataset.id)"
        >
          {{
            displayMetadataDataset === dataset.id
              ? 'Hide metadata'
              : 'Show metadata'
          }}
        </b-button>
        <div v-if="displayMetadataDataset === dataset.id">
          <table striped hover>
            <tr>
              <td class="property">Description</td>
              <td>{{ dataset.description }}</td>
            </tr>
            <tr>
              <td class="property">Keywords</td>
              <td>{{ dataset.keywords }}</td>
            </tr>
            <tr>
              <td class="property">Use Cases</td>
              <td>
                <a :href="dataset.use_case" target="_blank">{{
                  dataset.use_case
                }}</a>
              </td>
            </tr>
            <tr>
              <td class="property">Documentation</td>
              <td>
                <a :href="dataset.documentation" target="_blank">{{
                  dataset.documentation
                }}</a>
              </td>
            </tr>
            <tr>
              <td class="property">Dataset Owner</td>
              <td>{{ dataset.dataset_owner }}</td>
            </tr>
            <tr>
              <td class="property">Dataset Acces Manager</td>
              <td>{{ dataset.dataset_access_manager }}</td>
            </tr>
            <tr>
              <td class="property">Documentation</td>
              <td>
                <a :href="dataset.documentation" target="_blank">{{
                  dataset.documentation
                }}</a>
              </td>
            </tr>
          </table>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// register globally
export default {
  layout: 'dashboard',
  data() {
    return {
      value: [],
      datasets: [],
      displayMetadataDataset: null,
    };
  },
  async fetch() {
    this.datasets = await this.$nuxt.context.store.dispatch(
      'access_request/fetchDatasets'
    );
  },
  head() {
    return {
      title: 'RISIS Datasets - RISIS Workspace',
    };
  },
  methods: {
    setDisplayMetadataDataset(dataset) {
      if (this.displayMetadataDataset === dataset) {
        this.displayMetadataDataset = null;
      } else {
        this.displayMetadataDataset = dataset;
      }
    },
  },
};
</script>

<style scoped>
.top {
  margin-bottom: 10px;
}

.metadata-button {
  margin-top: 10px;
  float: right !important;
}

.title {
  font-weight: bold;
}

.list-item {
  padding: 10px 0px 10px 0px;
  margin: 10px 0px 10px 0px;
}

table tr:nth-child(odd) {
  background: #ccc;
}

.ml4 {
  margin-left: 4px;
}

.property {
  font-weight: bold;
  width: 230px;
}

table tr td {
  vertical-align: top;
  padding: 5px;
}

.info {
  padding: 10px;
  margin-bottom: 20px;
  border: 1px solid lightgray;
  border-radius: 2px;
}

.access-request-page-link {
  font-size: 15px;
  color: red;
}

.right {
  float: right;
  margin: 10px;
}
</style>
